////////////////////////////////////////////////////////////
//IsOrphan is added to USMerge
///////////////////////////////////////////////////////////
#include <iostream>
#include <fstream>
#include <map>
#include <pthread.h>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <cstring>
#include <omp.h>

#include "time.h"
#include "Utils.h"
#include "ULL4.h"
#include "USet.h"
#include "TomAlgorithm.h"
#include "MetaCluster.h"
#include "RelaPosi.h"
#include "USetLink.h"
#include "binner.h"
#include "SparseMatrix.h"


#define MAXRef 1200
#define MAXREADLEN 128

using namespace std;
/*
 *confidence is defined in binner.h
 */
////////////////////////////////////switch
const bool isTest2 = true;//print time, size, etc.
const bool isTest = false;
const int MaxLen = 500;//max length of each input line
//const int KmerLen = 32;
//2012-02-02
unsigned ReadLen = 0;
int StrLen = 50;
int StrLenLowCover = 50;
int MaxSpecies = 600;
int MinSpecies = 2;

int MetaKmerLen = 5;//kmer of kmer-distribution in MetaCluster3.0
int ReverSize = 136;
int NoReverSize = 256;

const int LARGESIZE = 1500;
const int SmallSize = 1000;
const bool useContig = false;
const int SmallContig = 8000;
const int SmallTSize = 3000;
int Orphan16merThresh = 200;
double Cdf_Cl = 1.65;//cdf of confidence level
double MC3_Thresh = 0.94;

//species #. can be fixed by user.
int ClusterSize = 0;

const int LinkThresh = 0;

int MinF[] = {2,2,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7,8,8,8,8,9,9,9,9,10,10,10,10,11,11,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,22,22,22,22,23,23,23,23,24,24,24,24,25,25,25,25,26,26,26,26,27,27,27,27,28,28,28,28,29,29,29,29,30,30,30,30,31,31,31,31,32,32,32,32,33,33,33,33,34,34,34,34,35,35,35,35,36,36,36,36,37,37,37,37,38,38,38,38,39,39,39,39,40,40,40,40,41,41,41,41,42,42,42,42,43,43,43,43,44,44,44,44,45,45,45,45,46,46,46,46,47,47,47,47,48,48,48,48,49,49,49,49,50,50,50,50,51,51,51,51,52,52,52,52,53,53,53,53,54,54,54,54,55,55,55,55,56,56,56,56,57,57,57,57,58,58,58,58,59,59,59,59,60,60,60,60,61,61,61,61,62,62,62,62,63,63,63,63,64,64,64,64,65,65,65,65,66,66,66,66,67,67,67,67,68,68,68,68,69,69,69,69,70,70,70,70,71,71,71,71,72,72,72,72,73,73,73,73,74,74,74,74,75,75,75,75,76,76,76,76,77,77,77,77,78,78,78,78,79,79,79,79,80,80,80,80,81,81,81,81,82,82,82,82,83,83,83,83,84,84,84,84,85,85,85,85,86,86,86,86,87,87,87,87,88,88,88,88,89,89,89,89,90,90,90,90,91,91,91,91,92,92,92,92,93,93,93,93,94,94,94,94,95,95,95,95,96,96,96,96,97,97,97,97,98,98,98,98,99,99,99,99,100,100,100,100,101,101,101,102,102,102,102,103,103,103,103,104,104,104,104,105};
////////////////////////////////////////variable
unsigned ReadNum = 0;
int GenoNum = 0;

ULL4*  Reads;//[ReadNum];
ULL4*  RevReads;//[ReadNum];
//int* MPGe;//[ReadNum/2];
//int* StartPosition;//[ReadNum];

USet* Type;//(ReadNum);
//USet* Type;//(ReadNum);
RelaPosi* RPosi;
bool* IsOrphan;
bool* isRemoved;
bool* isGood;//two double-wing

time_t rawtime;
struct tm* timeinfo;

char Buf[MaxLen];// buffer for input 
//typedef unsigned long long KmerType;
//typedef unsigned KmerType;

int** KmerDistri;
int* NSize;
int* Size16mer;
int* Total16mer;
int* Occur16mer;
map<int ,map<int,int> >Neighbor;

//IntNode** KmerMap = new IntNode*[1U<<28];
//CountKmerNode** KmerMap = new CountKmerNode*[1U<<28];
/*
inline void insertHash(unsigned id, unsigned ele,unsigned posi)
{
	unsigned hashid = id & 0xfffffff;
	IntNode* curr = KmerMap[hashid];
	if(curr == NULL)
	{
		KmerMap[hashid] =  new IntNode(id,NULL,ele,posi);
		return;
	}
	if(curr->kmer == id)
	{
		curr->push_back(ele,posi);
		return;
	}
	while(curr->next != NULL)
	{
		if(curr->kmer == id)
		{
			curr->push_back(ele,posi);
			return ;
		}
		else 
			curr = curr->next;
	}
	if(curr->kmer == id)
	{
		curr->push_back(ele,posi);
	}
	else
	{
		curr->next =  new IntNode(id,NULL,ele,posi);
	}
}
*/

bool testRC(const unsigned index,unsigned left,unsigned right)
{
	for(int i=0;i<32;i+=2)
	{
		if(((left>>i)&0x3) + (0x3&(right>>(30-i))) != 3U)
		{
			cerr << "ERROR: not reverse complement:"<<dec << index << "\t" << hex << left << "\t" << right << endl;
			return false;
		}
	}
	return true;
}

//int revs[3]={0,0,0};
/*
void mapinto(const unsigned int index)
{
	//int ReadLength = ReadLen[index];
	for(unsigned int i=0;i<=ReadLen-32;++i)
	{
		unsigned left =   (Reads[index]>> ((ReadLen-16-i)*2)).low;
		unsigned right=(RevReads[index]>> (i*2)).low;
///////////////////////////////////////////pick the smaller one
//test
		//testRC(index,left,right);
///////////////////////////////////////////pick the smaller one
		if(left <= right)
		{
			insertHash(left,(index),(i<<1));
		}
		else
		{
			insertHash(right,(index),((ReadLen-16-i)<<1)|1U);
		//	++revs[1];
		}
	}
}
*/

inline int min(int a,int b)
{
	return a < b ? a : b;
}

inline int max(int a,int b)
{
	return a > b ? a : b;
}

inline void getBitRead(int index)
{
	static int digit[129];
	const int readLen = ReadLen;

	for(int i=0;i<readLen;++i)
	{
		if(Buf[i]=='A')digit[i]=0;
		else if(Buf[i]=='C')digit[i]=1;
		else if(Buf[i]=='G')digit[i]=2;
		else if(Buf[i]=='T')digit[i]=3;
		else 
		{
	  //	  cerr<<"Error Input!"<<endl;
			digit[i]=Buf[i]%4;
		}
	}
	unsigned long long high=0ULL,mid_H=0ULL,mid_L=0LL,low=0ULL;
	int i=0;
	for(;i<readLen-96;++i)
	{
		high <<= 2;
		high |= digit[i];
	}
	for(;i<readLen-64;++i)
	{
		mid_H <<= 2;
		mid_H |= digit[i];
	}
	for(;i<readLen-32;++i)
	{
		mid_L <<= 2;
		mid_L |= digit[i];
	}
	for(;i<readLen;++i)
	{
		low <<= 2;
		low |= digit[i];
	}
	Reads[index] = ULL4(high,mid_H,mid_L,low);
//////////////////////////////////////////////////////////
	high=0ULL,mid_H=0ULL,mid_L=0LL,low=0ULL;
	i=readLen-1;
	for(;i>=96;--i)
	{
		high <<= 2;
		high |= 3-digit[i];
	}
	for(;i>=64;--i)
	{
		mid_H <<= 2;
		mid_H |= 3-digit[i];
	}
	for(;i>=32;--i)
	{
		mid_L <<= 2;
		mid_L |= 3-digit[i];
	}
	for(;i>=0;--i)
	{
		low <<= 2;
		low |= 3-digit[i];
	}
	RevReads[index] = ULL4(high,mid_H,mid_L,low);
}
/*
inline void compa_read(const int &position1,const int &position2,int &match,int &mismatch,const ULL4 &read1,const ULL4 &read2)
{
	if(position1 > position2)
	{
		int k=position1-position2;
		ULL4 differ= (read2>>(2*k));
		differ ^= (read1 & AndMask[ReadLen-k]);
		mismatch = differ.non0base();
		match = ReadLen-k-mismatch;
		//Note: can change == to ^, so that can return a value;
	}
	else if(position1 < position2)
	{
		int k=position2-position1;
		ULL4 differ= (read1>>(2*k));
		differ ^= (read2 & AndMask[ReadLen-k]);
		mismatch = differ.non0base();
		match = ReadLen-k-mismatch;
		//Note: can change == to ^, so that can return a value;
	}
	else
	{
		ULL4 differ= read1;
		differ ^= read2;
		mismatch = differ.non0base();
		match = ReadLen-mismatch;
	}
}
*/

void furtherunion(int t1,int t2)
{
	int type1 = Type->find(t1);
	int type2 = Type->find(t2);
	if(type1==type2)return;
	int size1=Type->getsize(type1);
	int size2=Type->getsize(type2);
	Type->Union(type1,type2);
	if(type1 == Type->find(type1))//remove type2
	{
		--NSize[type1/2];
		for(map<int,int>::const_iterator itr3 = Neighbor[type2].begin();itr3!=Neighbor[type2].end();++itr3)
		{
			int type3 = Type->find(itr3->first);
			if(type3==itr3->first && type3!=type1 && type3!=type2)
			{
				--NSize[type3/2];
				if(Neighbor[type1].count(type3)==0)
					++NSize[type1/2];
				if(Neighbor[type3].count(type1)==0)
					++NSize[type3/2];
				Neighbor[type1][type3] += Neighbor[type2][type3];
				Neighbor[type3][type1] =  Neighbor[type1][type3];
			}
		}
	}
	else
	{
		--NSize[type2/2];
		for(map<int,int>::const_iterator itr3 = Neighbor[type1].begin();itr3!=Neighbor[type1].end();++itr3)
		{
			int type3 = Type->find(itr3->first);
			if(type3==itr3->first && type3!=type1 && type3!=type2)
			{
				--NSize[type3/2];
				if(Neighbor[type2].count(type3)==0)
					++NSize[type2/2];
				if(Neighbor[type3].count(type2)==0)
					++NSize[type3/2];
				Neighbor[type2][type3] += Neighbor[type1][type3];
				Neighbor[type3][type2] =  Neighbor[type2][type3];
			}
		}
	}
	///////////////////////////////////merge kmer distri
	int typef = Type->find(type1);
	if(KmerDistri[type1/2]==NULL)
	{
		if(KmerDistri[type2/2]==NULL)return;
		if(typef == type1)
		{
			KmerDistri[type1/2]=new int[NoReverSize];
			for(int i=0;i<NoReverSize;++i)
			{
				KmerDistri[type1/2][i] = KmerDistri[type2/2][i];
			}
		}
	}
	else if(KmerDistri[type2/2]==NULL)
	{
		if(typef == type2)
		{
			KmerDistri[type2/2]=new int[NoReverSize];
			for(int i=0;i<NoReverSize;++i)
			{
				KmerDistri[type2/2][i] = KmerDistri[type1/2][i];
			}
		}
	}
	else
	{
		for(int i=0;i<NoReverSize;++i)
		{
			KmerDistri[typef/2][i] = KmerDistri[type1/2][i] + KmerDistri[type2/2][i];
		}
	}
	Size16mer[typef/2] = Size16mer[type1/2]+Size16mer[type2/2];
	Total16mer[typef/2] = Total16mer[type1/2]+Total16mer[type2/2];
	Occur16mer[typef/2] = Occur16mer[type1/2]+Occur16mer[type2/2];
}

//////////////////////////////////////////////////////////////////////
struct Node
{
	int start,end;
	Node* next;
};
void insertNode(Node *&Head,int startpoint)
{
	startpoint = fabs(startpoint);
	if(Head==NULL)
	{
		Head = new Node;
		Head->start = startpoint;
		Head->end = startpoint+ReadLen;
		Head->next = NULL;
		return;
	}
	else if(startpoint+ReadLen-1 < Head->start)
	{
		Node *fresh = new Node;
		fresh->start = startpoint;
		fresh->end = startpoint+ReadLen;
		fresh->next = Head;
		Head = fresh;
		return;
	}
	Node *curr = Head;
		while(curr!=NULL)
		{
			if(curr->end <startpoint)
			{
				if(curr->next == NULL || curr->next->start > startpoint+ReadLen-1)
				{
					Node *fresh = new Node;
					fresh->start = startpoint;
					fresh->end = startpoint+ReadLen-1;
					fresh->next = curr->next;
					curr->next = fresh;
					break;
				}
				curr = curr->next;
				continue;
			}
			else if(curr->start > startpoint)
			{
				curr->start = startpoint;
				break;
			}
			else if(curr->end >= startpoint+ReadLen-1)
					break;
			else 
			{
				if(curr->next == NULL || curr->next->start > startpoint+ReadLen)
					curr->end = startpoint+ReadLen-1;
				else
				{
					curr->end = curr->next->end;
					Node *dele = curr->next;
					curr->next = curr->next->next;
					delete dele;
				}
				break;
			}
		}
}

/////////////////////////////////////////////////////////////////
/*
void testSifS(int ofgid)
{
	static int count = 0;
	if(count > 0)return;
	++count;
	char tmp[100];
	sprintf(tmp,"%d",ofgid);
	ofstream ofstLR((string(tmp)+"SAMELR.sif").c_str());
	for(int i=0;i<ReadNum;++i)
		if(Type->find(i)==ofgid)
		{
			if(RPosi->anchoridL[i] >= 0 && Type->find(RPosi->anchoridL[i])==ofgid)
			ofstLR << i <<"_"<<StartPosition[i] << "\tpL_"<<RPosi->positionL[i]<<"\t" << RPosi->anchoridL[i]<<"_"<<StartPosition[RPosi->anchoridL[i]]<<endl;
			if(RPosi->anchoridR[i] >= 0 && Type->find(RPosi->anchoridR[i])==ofgid)
			ofstLR << i <<"_"<<StartPosition[i] << "\tpL_"<<RPosi->positionR[i]<<"\t" << RPosi->anchoridR[i]<<"_"<<StartPosition[RPosi->anchoridR[i]]<<endl;
		}
	ofstLR.close();
}
void testSif(int ofgid,int binsize,int maxsize)
{
	static int count = 0;
	if(count > 0)return;
	++count;
	char tmp[100];
	sprintf(tmp,"%d_%d_%d",ofgid,maxsize,binsize-maxsize);
	ofstream ofstLR((string(tmp)+"DIFFLR.sif").c_str());
	for(int i=0;i<ReadNum;++i)
		if(Type->find(i)==ofgid)
		{
			if(RPosi->anchoridL[i] >= 0 && Type->find(RPosi->anchoridL[i])==ofgid)
			ofstLR << i <<"_"<<StartPosition[i] << "\tpL_"<<RPosi->positionL[i]<<"\t" << RPosi->anchoridL[i]<<"_"<<StartPosition[RPosi->anchoridL[i]]<<endl;
			if(RPosi->anchoridR[i] >= 0 && Type->find(RPosi->anchoridR[i])==ofgid)
			ofstLR << i <<"_"<<StartPosition[i] << "\tpL_"<<RPosi->positionR[i]<<"\t" << RPosi->anchoridR[i]<<"_"<<StartPosition[RPosi->anchoridR[i]]<<endl;
		}
	ofstLR.close();
}
*/
/////////////////////////////////////////////////////////////////
void printCover(){}
/*
{
	///////////////////////////////////////////////output cluster coverage
	map<int,int>typemap;
	map<int,int>typemaprever;
	int sizecounter = 0;
	for(int i=0;i<ReadNum;++i)
	{
		if(Type->find(i)==i)
		{
			typemaprever[sizecounter]=i;
			typemap[i]=sizecounter++;
		}
	}
/////////////////////////////////////////////////////////////////////////////
	Node ***coverage = new Node**[sizecounter];
	for(int i=0;i<sizecounter;++i)
	{
		coverage[i]=new Node*[GenoNum];
		for(int j=0;j<GenoNum;++j)
			coverage[i][j]=NULL;
	}

	for(int i=0;i<ReadNum;++i)
	{
		insertNode(coverage[typemap[Type->find(i)]][MPGe[i/2]],StartPosition[i]);
	}
	cerr<<"start to output links."<<endl;
	const int DisSize = 10000;int Distri[DisSize];
	for(int i=0;i<DisSize;++i)Distri[i]=0;

	for(int i=0;i<sizecounter;++i)
	{
		if(Type->getsize(typemaprever[i])<=2)continue;
		int clucover = 0;
		for(int j=0;j<GenoNum;++j)
		{
			if(coverage[i][j]!=NULL)
			{
 				Node *curr = coverage[i][j];
				int covLen = 0,covStart=0,covEnd=0;
				covStart = curr->start;
				cout<<typemaprever[i]<<",\t"<<Type->getsize(typemaprever[i])<<",\t"<<i<<","<<j<<",\t";
				cout<<Size16mer[typemaprever[i]/2]<<",\t";
				int contigcounter=0;
				while(curr!=NULL)
				{
					++contigcounter;
					covLen += curr->end - curr->start;
					covEnd = curr->end;
					curr = curr->next;
				}cout<<contigcounter<<",\t"<<covLen<<",\t"<<covEnd-covStart<<",\t";

 				curr = coverage[i][j];
				while(curr!=NULL)
				{
					cout<<dec<<curr->start<<"--"<<curr->end<<",\t";
					curr = curr->next;
				}cout<<endl;
				if(clucover < covLen)
					clucover = covLen;

				curr = coverage[i][j];
				while(coverage[i][j]!=NULL)
				{
					coverage[i][j]=coverage[i][j]->next;
					delete curr;
					curr = coverage[i][j];
				}
			}
		}
		++Distri[clucover/500];
	}
	int largeindex=DisSize-1;
	while(Distri[largeindex]==0)largeindex--;
	cout<<"#. real coverage size:"<<endl;
	for(int i=0;i<=largeindex;++i)
		if(Distri[i]>0)
			cout << i*500 <<','<<Distri[i]<<endl;
	for(int i=0;i<sizecounter;++i)
	{
		for(int j=0;j<GenoNum;++j)
			delete coverage[i][j];
	}
	delete coverage;
}
*/

int *ReverPosition;
void printsize(bool PrintDis){}
/*
{
	map<int,int>type_maxGeno;

	map<int,int*>caltype;
	for(int i=0;i<ReadNum;i+=2)
	{
		int type = Type->find(i);
		if(caltype.count(type)==0)
		{
			caltype[type]=new int[GenoNum];
			for(int j=0;j<GenoNum;++j)
			{
				caltype[type][j] = 0;
			}
		}
		caltype[type][MPGe[i/2]]+=2;
	}
 
	int smallclu[10];
	for(int i=0;i<10;++i)smallclu[i]=0;
	int wrongreads = 0,correctread=0,smallsize = 0,outliers=0;
	const int DisSize = 10000;int Distri[DisSize];
	for(int i=0;i<DisSize;++i)Distri[i]=0;
	for(map<int,int*>::const_iterator itr = caltype.begin();itr != caltype.end();++itr)
	{
		int binsize = 0,maxsize = 0,tmp = 0,maxGeno = 0;
		for(int i=0;i<GenoNum;++i)
		{
			tmp = (itr->second)[i];
			binsize += tmp;
			if(maxsize < tmp)
			{
				maxsize = tmp;
				maxGeno = i;
			}
		}
		if(Type->getsize(itr->first)>=SmallSize)
			type_maxGeno[itr->first] = maxGeno;
		wrongreads += binsize-maxsize;
		correctread += maxsize;
		if(binsize < 10)
		{
			++smallsize;
			++smallclu[binsize];
		}
		if(binsize <= 2)
			++outliers;
		else
		{
			if(binsize != maxsize)
			{
				cout<<itr->first;
				for(int j=0;j<GenoNum;++j)
				{
					cout<<","<<(itr->second)[j];
				}cout<<endl;
			}
			if(binsize/500>=DisSize)
			{
				cerr<<"size error:"<<binsize<<",\t"<<LARGESIZE;
				for(int j=0;j<GenoNum;++j)
				{
					cerr<<",\t"<<(itr->second)[j];
				}cerr<<endl;
			}
			else
			++Distri[binsize/500];
		}
	}

/////////////////////////////////////////////////////////////////////////////
////get reverse conplement
	if(PrintDis)
	{
	for(int i=0;i<ReadNum/2;++i)
	{
		if(Type->find(i*2) != i*2 || KmerDistri[i]==NULL)continue;
		for(int j=0;j<NoReverSize;++j)
		{
			int rever = tomReverComple(j,MetaKmerLen);
			if(j<=rever)
			{
				KmerDistri[i][j] += KmerDistri[i][rever];
				KmerDistri[i][rever] = KmerDistri[i][j];
			}
		}
	}

	double** normaldistri = new double*[ReadNum/2];
	for(int i=0;i<ReadNum/2;++i)
	{
		if(Type->find(i*2) != i*2)
		{
			normaldistri[i]=NULL;
		}
		else if(KmerDistri[i]==NULL)
		{
			normaldistri[i]=NULL;
		}
		else
		{
			normaldistri[i] = tomNormalize_rever(KmerDistri[i],ReverPosition,MetaKmerLen,false);
			int kmersum = 0;
			for(int j=0;j<NoReverSize;++j)kmersum+=KmerDistri[i][j];
			if(PrintDis)
			{
				cout<<"Distri:,"<<2*i<<",,";
				for(int j=0;j<NoReverSize;++j)
					cout<<KmerDistri[i][j]<<",";
				cout<<endl;
			}
		}
	}

/////////////////////////////////////////////////////////////////////////////
////get kmer-distri distance
	//if(PrintDis)
/////////////////////////////////////////////////////////////////////////////
		double interdis = 0,intradis = 0;
		int intercount = 0,intracount = 0;
		int intrad[1000],interd[1000];
		for(int i=0;i<1000;++i)
			intrad[i]=interd[i]=0;
		
		int* type_max_1=new int[type_maxGeno.size()];
		int* type_max_2=new int[type_maxGeno.size()];int tmpcounter = 0;
		for(map<int,int>::const_iterator itr = type_maxGeno.begin();itr!=type_maxGeno.end();++itr)
		{
			type_max_1[tmpcounter]  =itr->first/2;
			type_max_2[tmpcounter++]=itr->second;
		}
#pragma omp parallel for
		for(int i=0;i<tmpcounter;++i)
		{
			int geno1 = type_max_2[i];
			double* distri1 = normaldistri[type_max_1[i]];
			if(distri1==NULL)continue;
			for(int j=0;j<tmpcounter;++j)
			{
				if(type_max_1[i] == type_max_1[j])continue;
				int geno2 = type_max_2[j];
				double* distri2 = normaldistri[type_max_1[j]];
				if(distri2==NULL)continue;
			
				if(geno1==geno2)
				{
					int speardis = spearDistance(distri1,distri2,ReverSize);
#pragma omp atomic
					intradis += speardis;
#pragma omp atomic
					++intracount;
#pragma omp atomic
					++intrad[speardis/10];
				}
				else
				{
					int speardis = spearDistance(distri1,distri2,ReverSize);
#pragma omp atomic
					interdis += speardis;
#pragma omp atomic
					++intercount;
#pragma omp atomic
					++interd[speardis/10];
				}
			}
		}
		cout<<"average interdistance:"<< interdis/intercount <<endl;
		int maxc=999;while(interd[maxc]==0)maxc--;
		for(int i=0;i<=maxc;++i)
			cout<<i<<","<<interd[i]<<endl;
		cout<<endl;
		cout<<"average intradistance:"<< intradis/intracount <<endl;
		maxc=999;while(intrad[maxc]==0)maxc--;
		for(int i=0;i<maxc;++i)
			cout<<i<<","<<intrad[i]<<endl;
		cout<<endl;
		delete[] type_max_1;
		delete[] type_max_2;
	}
/////////////////////////////////////////////////////////////////////////////
	int largeindex=DisSize-1;
	while(Distri[largeindex]==0)largeindex--;

	cout<<"#. of small reads size:"<<endl;
	for(int i=0;i<10;++i)
		if(smallclu[i])
			cout<<i<<","<<smallclu[i]<<endl;;
	cout<<"#. of reads size:"<<endl;
	for(int i=0;i<=largeindex;++i)
		if(Distri[i]>0)
			cout << i*500 <<','<<Distri[i]<<endl;
	cerr<<"SIZE LIMIT:"<<LARGESIZE<<endl;
	cerr<<"Total Reads:"<<ReadNum<<endl;
	cerr<<"Outlier reads:"<<2*outliers <<"\t"<<(2*outliers)/(double)ReadNum<<endl;
	cerr<<"Binning correct:"<<correctread<<",\tincorrect reads:"<<wrongreads<<endl;
	cerr<<"Binning accuracy:"<<1-(wrongreads)/(double)(ReadNum-outliers*2)<<endl;
	cerr<<"Bin size<10:"<<smallsize<<endl;
	cerr<<"Binning clusters:"<<caltype.size()-smallsize<<endl;
}
*/

//double confidence[129];
void pretreatment()
{
/////////////////////////////////////////////////////////////
////Calculate Masks
	AndMask[0]=ULL4(-1,-1,-1,-1);
	ULL4 masktemp = ULL4(-1,-1,-1,-1);
	for(int i=1;i<129;i++)
	{
		masktemp <<= 2;
		AndMask[i] = ~masktemp;
	}

/////////////////////////////////////////////////////////////
////confidence test
	double r = 0.01;//not exactly errorrate in this context
	double p=1+r*r-5*r/3;
	double var = p*(1-p);
	double Z = Cdf_Cl;//double Z = 1.65;//1.96;//for confidence level 0.95
	for(int i=0;i<129;++i)
		confidence[i] = i*p-sqrt(var*i)*Z;
	
	if(isTest2)
	{
		cerr << " confidence bases: " << endl;
		for(int i=0;i<129;++i)
			cerr << i <<":\t"<< confidence[i] <<endl;
	}
//////////////////////////////////////////////////////////
	for(unsigned i=0;i<HASHSIZE;++i)
	{
		KmerMap[i] = INULL;
	}
}


/*
void processVector()
{
//////////////////////////////////////////////////////////////Union
	int hashsize[18];for(int i=0;i<18;++i)hashsize[i]=0;
	for(int i=0;i<(1U<<28);++i)
	{
		IntNode* prev = KmerMap[i];
		if(prev == NULL)
		{
			++hashsize[0];//////////////////test
			continue;
		}
/////////////////////////////////////////////////////////////
		int tmpcount=0;
		IntNode* tmpnode = KmerMap[i];
		while(tmpnode!=NULL)
		{
			++tmpcount;
			tmpnode = tmpnode->next;
		}
		if(tmpcount<17)++hashsize[tmpcount];
		else ++hashsize[17];
////////////////////////////////////////////////////remove nodes with vector size 1
		IntNode* curr = prev->next;
		while(curr!=NULL)
		{
			if(curr->VSize<=1)
			{
				prev->next = curr->next;
				delete curr;
				curr = prev->next;
			}
			else
			{
				prev = curr;
				curr = curr->next;
			}
		}
		curr = KmerMap[i];
		if(curr->VSize<=1)
		{
			KmerMap[i] = curr->next;
			delete curr;
		}
	}
	////////////////////////////////////////////end of remove 
	if(isTest){
		cout<<"hash size: "<<endl;
		for(int i=0;i<18;++i)cout<<hashsize[i]<<endl;
		for(int i=0;i<18;++i)cerr<<hashsize[i]<<endl;
		cout<<"endl of hash size: "<<endl;
	}
}
*/

void printlinks(){}
/*
{
	ofstream ofsl("leftlinknodes.sif");
	ofstream ofs2("alledge.csv");
	cout<<"Left links:"<<endl;
	ofs2 << "type1,\ttype2,\tweight,\tcorrectness(0:false;1:true)"<<endl;
	for(map<int,map<int,int> >::const_iterator itr=Neighbor.begin();itr!=Neighbor.end();++itr)
	{
		int type1 = itr->first;
		if(Type->find(type1) != type1 || Type->getsize(type1)<=2)continue;

		for(map<int,int>::const_iterator itr2=itr->second.begin();itr2!=itr->second.end();++itr2)
		{
			int type2 = itr2->first;
			if(Type->find(type2) != type2 || Type->getsize(type2)<=2 || type1<=type2)continue;
			string node1="G",node2="G";
			char buf[20];
			sprintf(buf,"%d",MPGe[type1/2]);
			node1 += buf;node1 += "_";
			sprintf(buf,"%d",MPGe[type2/2]);
			node2 += buf;node2 += "_";
			if(itr2->second <= LinkThresh)continue;
			if(node1 != node2)
			{
				ofs2 << type1 <<","<< type2 <<"," << itr2->second <<","<<0 <<endl;
			}
			else
			{
				ofs2 << type1 <<","<< type2 <<"," << itr2->second <<","<<1 <<endl;
			}
			ofsl << node1 << type1 <<"\tEdge_"<<(itr2->second)<<"\t"<< node2 <<type2 <<endl;
		}
	}
	ofsl.close();
	ofs2.close();
}
*/

string getreadstr(ULL4 read)
{
	string result;
	for(unsigned i=0;i<ReadLen;++i)
	{
		unsigned dig = (read>>(i<<1)).low&3;
		string ch;
		if(dig==0)ch = "A";
		else if(dig==1)ch = "C";
		else if(dig==2)ch = "G";
		else ch = "T";
		result = ch + result;
	}
	return result;
}

void printAcc(int* finaltype,int ClustNum){}
/*
{
		cerr << "Predicted #. of Groups: " << ClustNum << endl;
		int* accmatrix[ClustNum];
		for(int i=0;i<ClustNum;++i)
		{
			accmatrix[i] = new int[GenoNum];
			for(int j=0;j<GenoNum;++j)
				accmatrix[i][j]=0;
		}
		for(int i=0;i<ReadNum;i+=2)
		{
			if(!IsOrphan[i])
				accmatrix[finaltype[i]][MPGe[i/2]] += 2;
		}
		int MaxC = 0, SumC = 0;
		for(int i=0;i<ClustNum;++i)
		{
			int TempMaxC = 0, TempSumC = 0;
			for(int j=0;j<GenoNum;++j)
			{
				TempSumC += accmatrix[i][j];
				if(TempMaxC < accmatrix[i][j])
					TempMaxC = accmatrix[i][j];
				cout << accmatrix[i][j] << "\t";
			}
			cout << 1.0* TempMaxC/TempSumC << "\t" << TempMaxC << "\t" << TempSumC << endl;
			MaxC += TempMaxC;
			SumC += TempSumC;
		}
		cout << "Precision:\t" << 1.0*MaxC/SumC << "\t" << MaxC << "\t" << SumC << endl;
		cerr << "Precision:\t" << 1.0*MaxC/SumC << "\t" << MaxC << "\t" << SumC << endl;

		MaxC = 0, SumC = 0;
		for(int i=0;i<GenoNum;++i)
		{
			int TempMaxC = 0, TempSumC = 0;
			for(int j=0;j<ClustNum;++j)
			{
				TempSumC += accmatrix[j][i];
				if(TempMaxC < accmatrix[j][i])
					TempMaxC = accmatrix[j][i];
				cout << accmatrix[j][i] << "\t";
			}
			cout << TempMaxC << "\t" << TempSumC << endl;
			MaxC += TempMaxC;
			SumC += TempSumC;
		}
		cout << "Sensitivity:\t" << 1.0*MaxC/SumC << "\t" << MaxC << "\t" << SumC << endl;
		cerr << "Sensitivity:\t" << 1.0*MaxC/SumC << "\t" << MaxC << "\t" << SumC << endl;

		for(int i=0;i<ClustNum;++i)
		{
			delete[]accmatrix[i];
		}
}
*/

void testType(const bool isContig = false,const int Thresh = 100){}
	/*
{
	static int TTNum = -1;
	++TTNum;

	cerr << "TTNum:\t" << endl;
	int* GSize = new int[GenoNum];
	for(int i=0;i<GenoNum;++i)
		GSize[i] = 0;
	for(unsigned i=0;i<ReadNum;i+=2)
		GSize[MPGe[i/2]] += 2;

	int* gcount = new int[GenoNum];
	for(unsigned i=0;i<GenoNum;++i)
		gcount[i] = 0;
	if(isContig)
	{
		for(unsigned i=0;i<ReadNum;i+=2)
		{
			if(IsOrphan[i] || Size16mer[(Type->find(i))/2]<Thresh)
				gcount[MPGe[i/2]] += 2;
		}
	}
	else
	{
		for(unsigned i=0;i<ReadNum;i+=2)
		{
			if(IsOrphan[i] || Type->getsize(i)<Thresh)
				gcount[MPGe[i/2]] += 2;
		}
	}
	for(int i=0;i<GenoNum;++i)
		cerr << gcount[i] << "\t" << GSize[i] <<"\t" <<gcount[i]/(double)GSize[i] << endl;

	delete[] GSize;
	delete[] gcount;
}
*/

void printtime()
{
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	cerr<<asctime(timeinfo);
}

int main(int argc, char* argv[])
{
	//Important! readlength should belong to (50,128]. Default value = 75.
//	AddParameter("ReadLen", &ReadLen, INTEGER);
	//We use q-mer distribution in Phase 3. Here you can set qmer = 4 or 5. Default value = 4.
	AddParameter("qmer", &MetaKmerLen, INTEGER);
	//You can fix the #. of species. Default value = 0. 
	//In this case, the program will predict the #. of species.
	AddParameter("Species", &ClusterSize, INTEGER);
	//We use binary search to predict #. of species, this is max value for the first iteration.
	//Set this number properly will improve the performance and speed up the program. Default = 600.
	AddParameter("MaxSpecies", &MaxSpecies, INTEGER);
	//We use binary search to predict #. of species, this is min value for the first iteration. 
	//Set this number properly will improve the performance and speed up the program. Default = 2.
	AddParameter("MinSpecies", &MinSpecies, INTEGER);
	//wmer in phase 1, default = 50;
	AddParameter("wmer", &StrLen, INTEGER);
	//wmer for low coverage read , default = 25; if a smaller value is needed, mapinto() should be modifed to mappint more 16-mers.
	AddParameter("lowwmer", &StrLenLowCover, INTEGER);
	//Threshold for further-merge in MetaCluster 3.0. Default valule = 0.9. If you set this value larger, program will conceptually predict more species. 
	AddParameter("MetaC3Threshold", &MC3_Thresh, FLOAT);
	//groups of size smaller than Orphan16merThresh will be considered as orphans
	AddParameter("Orphan", &Orphan16merThresh, INTEGER);
	//the confidence level to compare w-mer-shared read pairs. please check the CDF of normal distribution. e.g. defalut value 1.65 corresponds to confidence level 0.95.
	AddParameter("cdfconfidence", &Cdf_Cl, FLOAT);
	ProcessParameters(argc,argv);
	srand((unsigned)time(NULL));
	//////////////////////////////////////////////////////
	//get read length
	{
		string path = argv[1];
		const int MAXLINE = 10000000;
		char* Buf = new char[MAXLINE];
		ReadLen = 0;
		ifstream ifs(path.c_str());
		if(ifs.fail()){
			cerr << "File open failed:\t"<<path<<endl;
			exit(-1);
		}
		ifs.getline(Buf,MAXLINE);
		ifs.getline(Buf,MAXLINE);
		while(!ifs.eof() && Buf[0]!='>'){
			ReadLen += strlen(Buf);
			ifs.getline(Buf,MAXLINE);
		}
		ifs.close();
		cerr << "Read length: " << ReadLen << endl;
		if(ReadLen > 128){
			cerr << "Read length should be <= 128." << endl;
			exit(-1);
		}
		ReadNum = 0;
		ifs.open(path.c_str());
		while(!ifs.eof() ){
			ifs.getline(Buf,MAXLINE);
			if(Buf[0]=='>')
				++ReadNum;
		}
		ifs.close();
		delete[]Buf;
	}

	//KmerMap = new IntNode*[1<<28];
	//cout<<"ps "<<psCount++<<endl;system("ps ux");
	KmerMap = new INodeRef[HASHSIZE];

	//cout<<"ps "<<psCount++<<endl;system("ps ux");
	ReverPosition = getReverPosition(MetaKmerLen);
	//cout<<"ps "<<psCount++<<endl;system("ps ux");
	ReverSize = tomReverSize(MetaKmerLen);
	NoReverSize = 1<<(MetaKmerLen<<1);
	//cout<<"ps "<<psCount++<<endl;system("ps ux");
/////////////////////////////////////////////////////////////////////
////get the path
	string strpath(argv[1]);
	int ttid = 0;char* bufff = new char[100];
	for(int i=strlen(argv[1]);i>=0;--i)
	{
		if(argv[1][i]=='/')
		{
			strcpy(bufff,argv[1]+i+1);
			break;
		}
		else if(i==0)
		{
			strcpy(bufff,argv[1]);
		}
	}

	string file(bufff);
	string outputStr = file + ".out";
	string midfile = file + ".mid";
///////////////////////////////////////////////////////pre treatment
	if(isTest2)
	{
		cerr << "NodeIDPosi:\t"<<sizeof(NodeIDPosi)<<endl;
		cerr << "test:"<<endl;
		cerr << StrLen <<endl;
		cerr << Orphan16merThresh <<endl;
		cerr << Cdf_Cl <<endl;
		cerr << MC3_Thresh <<endl;
		cerr << StrLenLowCover <<endl;

		cerr<<"ReverSize:" << ReverSize <<endl;
		cerr<<"NoReverSize:" << NoReverSize <<endl;

		cerr<<"input path:" << strpath <<endl;
		cerr<<"input file:" << file <<endl;
		cerr<<"output file:" << outputStr <<endl;
		cerr<<"mid file:" << midfile <<endl;
	}
///////////////////////////////////////////////////////pre treatment
/*	string command = (string("wc ")+argv[1]+" -l > "+file+".tmp");
	system(command.c_str());
	long long readNumtmp = 0;
	ifstream ifs((file+".tmp").c_str());
	ifs >> readNumtmp;
	ifs.close();
	system((string("rm ")+file+".tmp").c_str());
	ReadNum = readNumtmp/2;*/
///////////////////////////////////////////////////////pre treatment
/*
	ifstream ifs(strpath.c_str());
	if(ifs.fail())
	{
		cerr<<"file open failed!"<<endl;
		exit(1);
	}
	ReadNum=0;
	while(!ifs.eof())
	{
		ifs.getline(Buf,MaxLen);
		if(Buf[0]!='>')
		{
			break;
		}
		ifs.getline(Buf,MaxLen);
		++ReadNum;
	}
	ifs.close();
	*/

	if(isTest2)
		cerr << "ReadNum:\t"<<ReadNum<<endl;

	static int psCount = 1;

	if(isTest2)
		cout<<"ps "<<psCount++<<endl;system("ps ux");
	Reads = new ULL4[ReadNum];
	RevReads = new ULL4[ReadNum];
	//ReadLen = new int[ReadNum];
	if(isTest2)
		cout<<"ps "<<psCount++<<endl;system("ps ux");//6

	//////////////////////can be removed.
//	MPGe = new int[ReadNum/2];
//	StartPosition = new int[ReadNum];
	//////////////////////////////////////////////////

	Type = new USet(ReadNum);
//	Type = new USet(ReadNum);
	IsOrphan = new bool[ReadNum];
	Size16mer = new int[ReadNum/2];
	Total16mer = new int[ReadNum/2];
	Occur16mer = new int[ReadNum/2];
	string *strings = new string[ReadNum];
	for(int i=0;i<ReadNum/2;++i)Size16mer[i]=0;
	for(int i=0;i<ReadNum/2;++i)Total16mer[i]=0;
	for(int i=0;i<ReadNum/2;++i)Occur16mer[i]=0;
	for(int i=0;i<ReadNum;++i)IsOrphan[i]=false;
	if(isTest2)
		cout<<"ps "<<psCount++<<endl;system("ps ux");//7
///////////////////////////////////////////////////////////
////get reads
	ifstream ifs(strpath.c_str());
	if(ifs.fail())
	{
		cerr<<"file open failed!"<<endl;
		exit(1);
	}
	int ReadsIndex = 0;
	int tmp,tmp2,startp=0,genotype = -1;

	char *buf = new char [MaxLen];
	ifs.getline(buf,MaxLen);
	while(!ifs.eof() && ReadsIndex != ReadNum){
		if(buf[0]!='>'){
			cerr<<"format incorrect: "<<ReadsIndex<<endl;
			exit(-1);
		}
		sscanf(buf,">read%d_%d/%d\t%d",&genotype,&tmp,&tmp2,&startp);
//		if(genotype > GenoNum)GenoNum = genotype;
		strings[ReadsIndex] = buf;

		string acgt;
		ifs.getline(buf,MaxLen);
		do{
			acgt += buf;
			ifs.getline(buf,MaxLen);
		}while(!ifs.eof()&&buf[0]!='>');
		if(acgt.length() != ReadLen){
			cerr << "Error: Read length uneven: " << ReadLen <<" and "<<acgt.length() << endl;
			cerr << acgt << endl;
			exit(-1);
		}
		//////////////////////////////////////
		//get start position & read
		strcpy(Buf,acgt.c_str());
		getBitRead(ReadsIndex++);
	}
	delete[] buf;
	ifs.close();
	++GenoNum;
	if(isTest2)
		cout<<"ps "<<psCount++<<endl;system("ps ux");//8

	pretreatment();
	if(isTest2)
		cout<<"ps "<<psCount++<<endl;system("ps ux");//9

	if(isTest2)
		cerr << "ReadIndex:\t"<<ReadsIndex<<"\tGenoNum:"<<GenoNum<<endl;
/////////////////////////////////////////////////////////////
////Get time
	if(isTest2){
		cerr<<"Start to map. time is: ";
		printtime();
	}
//////////////////////////////////////////////////////////////
////map reads
#pragma omp parallel for
	for(int i=0;i<ReadNum;i+=2)
	{
		unsigned long long low,mid_H,mid_L,high;
		low = Reads[i].low;mid_H=Reads[i].mid_H;mid_L=Reads[i].mid_L;high=Reads[i].high;
		Reads[i].low=RevReads[i].low;Reads[i].mid_H=RevReads[i].mid_H;Reads[i].mid_L=RevReads[i].mid_L;Reads[i].high=RevReads[i].high;
		RevReads[i].low=low;RevReads[i].mid_H=mid_H;RevReads[i].mid_L=mid_L;RevReads[i].high=high;
	}
///////////////////////////////////////////////////////
	if(isTest2)
	{
		system("ps ux ");cerr<<"iniMap()"<<endl;printtime();
	}
	iniMap();
	if(isTest2)
	{
		cout<<"after inimap"<<endl;
		cerr<<"after inimap"<<endl;printtime();
	}
	countKmer(ReadNum, ReadLen, Reads, RevReads);
	if(isTest2)
	{
		testVCount();
		cout<<"NodesCount:"<<NodeCount<<"\t"<<sizeof(IntNode)<<"\t"<<sizeof(IntNode)*NodeCount<<endl;
		system("ps ux ");cerr<<"iniArrayMap()"<<endl;printtime();
	}
	iniArrayMap();
	if(isTest2)
	{
		cout<<"end of iniArrayMaps."<<endl;
		system("ps ux ");cerr<<"before mapRead"<<endl;printtime();
	}
	mapReads(ReadNum, ReadLen, Reads, RevReads,IsOrphan);
	if(isTest2)
	{
		cout<<"end of mapreads."<<endl;
		system("ps ux ");cerr<<"after mapReads"<<endl;printtime();
	}
//	if(isTest)
	{
	//	const unsigned KL = 16;
	//	const unsigned long long KLmask = 0xffffffff;
	//	const unsigned KL = 20;
	//	const unsigned long long KLmask = 0xffffffffff;
		const unsigned KL = 32;
		const unsigned long long KLmask =~( 0ULL);
	//	const unsigned KL = 32;
	//	const unsigned long long KLmask = 0xffffffffffffffff;
	//	const unsigned KL = 40;
	//	const ULL4 KLmask (0,0,0xffff,0xffffffffffffffff);
	
	//	const unsigned KL = 32;
	//	const ULL4 KLmask (0,0,0,0xffffffffffffffff);
		cerr << "KL:\t" << KL << endl;
		cerr << "KLmask:\t" << KLmask << endl;
		const int DisSize = 200;
//		int** sumDistri = new int*[GenoNum];
//		int** maxDistri = new int*[GenoNum];
		int* sumOcc = new int[ReadNum];
		int* maxOcc = new int[ReadNum];
	/*
		for(int i=0;i<GenoNum;++i)
			sumDistri[i] = new int[DisSize];
		for(int i=0;i<GenoNum;++i)
			maxDistri[i] = new int[DisSize];
			*/
		const unsigned INodeNum = INodePool.getNodeNum();


		/*
		for(int i=0;i<GenoNum;++i)
			for(int j=0;j<DisSize;++j)
			{
				sumDistri[i][j] = 0;
				maxDistri[i][j] = 0;
			}
		*/
		for(int i=0;i<ReadNum;++i)
		{
			maxOcc[i] = 0;
			sumOcc[i] = 0;
		}
		cerr << "test 1" << endl;
//		int printC = 0;
#pragma omp parallel for schedule(dynamic)
		for(unsigned i=0;i<INodeNum;++i)
		{
			IntNode* node = INodePool.getRef(i);
			ULL4 read1;
			map<unsigned long long,vector<unsigned> >candidate;
		//	map<ULL4,vector<unsigned> >candidate;
			for(NodeIDPosi* map_it2 = node->myvector;map_it2 != (node->myvector)+node->VSize; ++map_it2)
			{
				int id = (*map_it2).id;
				int isRev = (*map_it2).posi & 1U;
				unsigned position = ((*map_it2).posi)>>1;
				if(isRev)	read1 = RevReads[id];
				else	read1 = Reads[id];
				if(ReadLen>=KL+position)
				{
					candidate[((read1>>((ReadLen-KL-position)<<1)).low) & KLmask].push_back(id);
		//			candidate[((read1>>((ReadLen-KL-position)<<1))) & KLmask].push_back(id);
/*					if(printC < 30)
		//				cerr<<hex<<(((read1>>(unsigned((ReadLen-KL-position)<<1))))&KLmask)<<"\t"<<dec<<isRev<<"\t"<<position<<((ReadLen-KL-position)<<1)<<endl;;
						cerr<<hex<<(((read1>>(unsigned((ReadLen-KL-position)<<1))).low)&KLmask)<<"\t"<<dec<<isRev<<"\t"<<position<<((ReadLen-KL-position)<<1)<<endl;;
					*/
				}
			}
			/*
			if(printC < 30)
			{
				cerr << endl << endl;
				++printC;
			}
			*/
			for(map<unsigned long long,vector<unsigned> >::const_iterator itr = candidate.begin();itr!=candidate.end();++itr)
		//	for(map<ULL4, vector<unsigned> >::const_iterator itr = candidate.begin();itr!=candidate.end();++itr)
			{
				int count = itr->second.size();
				for(vector<unsigned>::const_iterator itr2 = (itr->second).begin();itr2!=(itr->second).end();++itr2)
				{
#pragma omp atomic
					sumOcc[*itr2] += count;
					if(count > maxOcc[*itr2])
						maxOcc[*itr2] = count;
				}
			}
		}
		cerr << "test 2" << endl;
//		cout << " sumDistri:\t" << endl;
		/*
		for(int i=0;i<ReadNum;++i)
		{
			if(sumOcc[i] >= DisSize)
				++sumDistri[MPGe[i/2]][DisSize-1];
			else
				++sumDistri[MPGe[i/2]][sumOcc[i]];
		}
		for(int i=0;i<GenoNum;++i)
		{
			for(int j=0;j<DisSize;++j)
				cout << sumDistri[i][j] << "\t";
			cout << endl;
		}
		for(int i=0;i<ReadNum;++i)
		{
			if(maxOcc[i] > DisSize)
				++maxDistri[MPGe[i/2]][DisSize-1];
			else
				++maxDistri[MPGe[i/2]][maxOcc[i]];
		}
		cout << " maxOcc:\t" << endl;
		for(int i=0;i<GenoNum;++i)
		{
			for(int j=0;j<DisSize;++j)
				cout << maxDistri[i][j] << "\t";
			cout << endl;
		}
		*/
		for(int i=0;i<ReadNum;++i)
		{
			if(maxOcc[i]<=4)
				IsOrphan[i] = true;
		}
		delete[]sumOcc;
		delete[]maxOcc;
		/*
		for(int i=0;i<GenoNum;++i)
			delete[]sumDistri[i];
		for(int i=0;i<GenoNum;++i)
			delete[]maxDistri[i];
		delete[]sumDistri;
		delete[]maxDistri;
		*/
	}
	unsigned orphcount = 0;
	for(int i=0;i<ReadNum;++i)
	{
		if(IsOrphan[i])
			++orphcount;
	}
	cerr << "orphcount:\t" << orphcount << endl;
	cerr << "Non-orphan:\t" << ReadNum-orphcount << endl;

	ofstream ofsorph((midfile+".isorphan").c_str());
	for(int i=0;i<ReadNum;++i)
	{
		if(IsOrphan[i])
			ofsorph << '1' << endl;
		else 
			ofsorph << '0' << endl;
	}
	ofsorph.close();
//	exit(-1);
///////////////////////////////////////////

	
	/*
#pragma omp parallel for schedule(dynamic)
	for(unsigned curr = 0;curr<INodePool.getNodeNum();++curr)
		INodePool.setVSize(curr,0);

	mapReads(ReadNum, ReadLen, Reads, RevReads,IsOrphan);
	
	*/
	
//	exit(-1);
///////////////////////////////////////////////////////
////map result and binning result
	if(isTest2)
		cerr<<dec<<"size:\t"<<StrLen<<endl;//<<"\t"<<kmermapsize<<endl;
/////////////////////////////////////////////////////////////
////Get time
	if(isTest2){
		cerr<<"Start to bin. time is: ";
		printtime();
	}
/////////////////////////////////////////////////////////////
	vector<pairlong> ITR;
	if(isTest)
		testVector(ITR);

	testType();
	/*
	for(int i=0;i<HASHSIZE;++i)
	{
		for(INodeRef curr = KmerMap[i];curr != INULL;curr = INodePool.getNext(curr))
		{
			if(INodePool.getVSize(curr) > 1)
				ITR.push_back(pairlong(curr));
		}
	}
	*/
	const unsigned INodeNum = INodePool.getNodeNum();
	for(unsigned i=0;i<INodeNum;++i)
	{
		ITR.push_back(pairlong(i));
	}
	sort(ITR.begin(),ITR.end());

	if(isTest)
		testVector(ITR);
	delete[]KmerMap;
	KmerMap = NULL;
	/////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////
	//sort the vectors to reduce the cost of phase 1 grouping
	
#pragma omp parallel for schedule(dynamic)
	for(unsigned curr=0;curr<INodeNum;++curr)
		sort(INodePool.getVector(curr),INodePool.getVector(curr)+INodePool.getVSize(curr));

	/*
	for(int i=0;i<HASHSIZE;++i)
	{
		INodeRef curr = KmerMap[i];
		while(curr!=INULL)
		{
			sort(INodePool.getVector(curr),INodePool.getVector(curr)+INodePool.getVSize(curr));
			curr = INodePool.getNext(curr);
		}
	}
	*/
	/////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////
	if(isTest2){
		cerr <<"ITR size:"<<ITR.size()<<"\t"<<sizeof(pairlong)<<endl;
		printtime();
	}
	cerr<<"INode:\t"<<INodePool.getNodeNum()<<endl;

	if(isTest2){
		cerr <<"get eqvl class:" << endl;
		printtime();
	}
	/*

	int TP=0,TN=0,FP=0,FN=0;
	int shareL = 0;
	int itrstart = 0,itrend = 0;
#pragma omp parallel for schedule(dynamic)
	for(unsigned curr = 0;curr<INodeNum;++curr)
	{
	//	for(IntNode* node = KmerMap[i1];node != NULL;node = node->next)
	//	for(INodeRef curr = KmerMap[i1];curr != INULL;curr = INodePool.getNext(curr))
	//	{
			IntNode* node = INodePool.getRef(curr);
			int sub_size = (node->VSize);
			if(sub_size<2)
			{
				continue;
			}
	
			int* indexes=new int[sub_size];
			int* positions=new int[sub_size];int temp=0;
			int* isRev=new int[sub_size];
			for(NodeIDPosi* map_it2 = node->myvector;map_it2 != (node->myvector)+node->VSize; ++map_it2)
			{
				indexes[temp]=((*map_it2).id);
				isRev[temp]=((*map_it2).posi & 1U);//last bit is a flag
				positions[temp++]=((*map_it2).posi)>>1;//last bit is a flag
			}
	
			ULL4 read1,read2;
			for(int i=0;i<sub_size;++i)
			{
				int indexes1 = indexes[i];
	
				if(isRev[i])	read1 = RevReads[indexes1];
				else	read1 = Reads[indexes1];
	
				for(int j=i+1;j<sub_size && positions[j]==positions[i];++j)
				{
					int indexes2 = indexes[j];

					if(Type->find(indexes1)==Type->find(indexes2))
						continue;
					/////////////////////////////////////////////////////////////////////////////////////
					if(isRev[j])	read2 = RevReads[indexes2];
					else read2 = Reads[indexes2];
					int mismatch = (read1^read2).non0base();
					int match = ReadLen-mismatch;
					/////////////////bin
				//	if(match >= StrLen && (match-StrLen >= confidence[ReadLen-StrLen]))
					if(match >= confidence[ReadLen])
				//	if(match >= ReadLen*0.9)
					{
						omp_set_lock(&type_lock);
						Type->Union(indexes1,indexes2);
						omp_unset_lock(&type_lock);
					}
					
					if(Type->find(indexes1) == Type->find(indexes2))
					{
						if(StartPosition[indexes1] == StartPosition[indexes2])
#pragma omp atomic
							++TP;
						else
#pragma omp atomic
							++FP;
					}
					else
					{
	//					omp_set_lock(&type_lock);
						if(StartPosition[indexes1] == StartPosition[indexes2])
#pragma omp atomic
							++FN;
						else
#pragma omp atomic
							++TN;
	//					omp_unset_lock(&type_lock);
					}
					
				}
			}
			delete[]indexes;delete[]positions;delete[]isRev;
	//	}
	}
	cerr<<"TP:\t"<<TP<<endl;
	cerr<<"FP:\t"<<FP<<endl;
	cerr<<"TN:\t"<<TN<<endl;
	cerr<<"FN:\t"<<FN<<endl;
	cerr<<"shareL:\t"<<shareL<<endl;
	int* isEqualto = new int[ReadNum];
	for(int i=0;i<ReadNum;++i)
		isEqualto[i] = Type->find(i);
////////////////////////////////////////////////////////
////error correction & fix anchor
	USetLink *usetlink = new USetLink(Type);
#pragma omp parallel for
	for(int i=0;i<ReadNum;++i)
	{
		if(usetlink->firstele[i] == NULL)
			continue;
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

		int GeneralRead[MAXREADLEN][4];
		for(int j=0;j<ReadLen;++j)
			for(int k=0;k<4;++k)
				GeneralRead[j][k]=0;
		for(UsetNode* ele = usetlink->firstele[i];ele != NULL; ele = ele->next)
		{
			int id = ele->value;
			int mis1 = (Reads[i]^Reads[id]).non0base();
			int mis2 = (Reads[i]^RevReads[id]).non0base();
			ULL4 currRead;
			if(mis1 > mis2)
				currRead = RevReads[id];
			else 
				currRead = Reads[id];

			//GeneralRead[0] is the highest base in ULL4(i.e. first base of original read).
			for(int i=0;i<ReadLen;++i)
				++GeneralRead[ReadLen-1-i][(currRead>>(i<<1)).low & 0x3];
		}
	//	string anchori = read2str(Reads[i]);
		int fixedread[MAXREADLEN];
		for(int j=0;j<ReadLen;++j)
		{
			int maxid = 0;
			int max = GeneralRead[j][0];
			for(int k=1;k<4;++k)
			{
				if(GeneralRead[j][k]>max)
				{
					maxid = k;
					max = GeneralRead[j][k];
				}
			}
			fixedread[j] = maxid;
		}
		ULL4 fixed = array2read(fixedread, ReadLen);
		Reads[i] = fixed;
		RevReads[i] = array2rcread(fixedread, ReadLen);
	}
	delete usetlink;
////////////////////////////////////////////////////////
////mate-pair
/////////////////////////////////////////////////////////////////
	if(isTest2)
	{
		cerr << "Start to get position. time is: ";
		printtime();
	}
//////////////////////////////////////////////////////////////////////////////////
	RPosi = new RelaPosi(ReadNum);
	itrend = ITR.size();
#pragma omp parallel for schedule(dynamic)
	for(int itrind = 0;itrind<itrend;++itrind)
	{
	//	cout <<endl << "itrind:\t" <<itrind<< endl;
	//	IntNode* node = ITR[itrind].node;
		IntNode* node = INodePool.getRef(ITR[itrind].node);
		int sub_size = (node->VSize);
		if(sub_size<2)
		{
			continue;
		}

		int* indexes=new int[sub_size];
		int* positions=new int[sub_size];int temp=0;
		int* isRev=new int[sub_size];
		for(NodeIDPosi* map_it2 = node->myvector;map_it2 != (node->myvector)+node->VSize; ++map_it2)
		{
			if(isEqualto[(*map_it2).id] != (*map_it2).id)continue;
			indexes[temp]=((*map_it2).id);
			isRev[temp]=((*map_it2).posi & 1U);//last bit is a flag
			positions[temp++]=((*map_it2).posi)>>1;//last bit is a flag
		}
		sub_size = temp;

		ULL4 read1,read2;
		for(int i=0;i<sub_size;++i)
		{
			int indexes1 = indexes[i];

			int scorex = 0;
			if(isRev[i])	
			{
				read1 = RevReads[indexes1];
				scorex = RPosi->scoreR[indexes1];
			}
			else
			{	
				read1 = Reads[indexes1];
				scorex = RPosi->scoreL[indexes1];
			}

			for(int j=i+1;j<sub_size;++j)
			{
				int indexes2 = indexes[j];
				int scorey = 0;
				if(isRev[j])
				{	
					read2 = RevReads[indexes2];
					scorey = RPosi->scoreL[indexes2];
				}
				else 
				{
					read2 = Reads[indexes2];
					scorey = RPosi->scoreR[indexes2];
				}
				
				if(ReadLen-positions[j]+positions[i] <= min(scorex,scorey))
				{
					break;
				}


				int match,mismatch;
				compa_read(ReadLen,positions[i],positions[j],match,mismatch,read1,read2);
				if(match >= confidence[match+mismatch])
					RPosi->setPosi(indexes1,indexes2,positions[j]-positions[i],isRev[i],isRev[j],match-mismatch);
			}
		}
		delete[]indexes;delete[]positions;delete[]isRev;
	}
	if(isTest2)
	{
		cerr<<"start to uni Rev:"<<endl;
		printtime();
	}
//////////////////////////////////////////////////////////////////////////////////
//process
//////////////////////////////////////////////////////////////////////////////////
	int* RefL = new int[ReadNum];
	int* RefR = new int[ReadNum];
	for(int i=0;i<ReadNum;++i)
		RefL[i] = RefR[i] = 0;
	for(int i=0;i<ReadNum;++i)
	{
		int left  = RPosi->anchoridL[i];
		int right = RPosi->anchoridR[i];
		if(left >= 0)
		{
			if(RPosi->isRevL[i])
				++RefL[left];
			else
				++RefR[left];
		}
		if(right >= 0)
		{
			if(RPosi->isRevR[i])
				++RefR[right];
			else
				++RefL[right];
		}
	}

	int goodcount = 0;
	isGood = new bool[ReadNum];
	isRemoved = new bool[ReadNum];
	for(int i=0;i<ReadNum;++i)
		isRemoved[i] = false;
	for(int i=0;i<ReadNum;++i)
	{
		int left  = RPosi->anchoridL[i];
		int right = RPosi->anchoridR[i];
		if(left>=0 && (RPosi->anchoridL[left]==i || RPosi->anchoridR[left]==i)
		&& right>=0 && (RPosi->anchoridL[right]==i || RPosi->anchoridR[right]==i)
		&& RefR[i]==1 && RefL[i] == 1)
		{
			isGood[i] = true;
			++goodcount;
		}
		else
			isGood[i] = false;
	}
	cerr<<"goodcount:\t"<<goodcount<<endl;
	for(int i=0;i<ReadNum;++i)
	{
		if(isGood[i])continue;
		int left  = RPosi->anchoridL[i];
		int right = RPosi->anchoridR[i];
		if((left<0||(left >= 0 && RPosi->anchoridL[left]!=i && RPosi->anchoridR[left]!=i))
			&& (right<0||(right >= 0 && RPosi->anchoridL[right]!=i && RPosi->anchoridR[right]!=i)))
			isRemoved[i] = true;
		else if(left>=0 && RPosi->anchoridL[left] != i && RPosi->anchoridR[left]!=i
		&& right>=0 && (RPosi->anchoridL[right]==i || RPosi->anchoridR[right]==i))
		{
			if(!isGood[right])
			{
				isRemoved[i]=true;
				if(RPosi->anchoridL[right]==i)
					RPosi->anchoridL[right]=-2;
				else
					RPosi->anchoridR[right]=-2;
			}
		}
		else if(right >= 0 && RPosi->anchoridL[right]!=i && RPosi->anchoridR[right]!=i
		&&	left>=0 && (RPosi->anchoridL[left]==i || RPosi->anchoridR[left]==i))
		{
			if(!isGood[left])
			{
				isRemoved[i]=true;
				if(RPosi->anchoridL[left]==i)
					RPosi->anchoridL[left]=-2;
				else
					RPosi->anchoridR[left]=-2;
			}
		}
	}

//////////////////////////////////////////////////////////////////////////////////
////Consensus
//////////////////////////////////////////////////////////////////////////////////
//test RelaPosi
	int LT=0,LF=0,RT=0,RF=0;
	int TLT=0,TLF=0,TRT=0,TRF=0;
	int ccount1=0,ccount2=0;
	for(int i=0;i<ReadNum;++i)
	{
		if(RPosi->anchoridL[i] >= 0)
		{
			if(MPGe[i/2] == MPGe[RPosi->anchoridL[i]/2])
				++TLT;
			else 
				++TLF;

			int deltap = abs(StartPosition[i]-StartPosition[RPosi->anchoridL[i]]);
			if(abs(StartPosition[i]-StartPosition[RPosi->anchoridL[i]])==RPosi->positionL[i])
				++LT;
			else
			{
				++LF;
				if(ccount1<10)
				{
					cout<<"StartPositionL:\t"<<StartPosition[i]<<"\t"<<StartPosition[RPosi->anchoridL[i]]<<"\t"<<RPosi->positionL[i]<<endl;
					++ccount1;
				}
			}
		}
		if(RPosi->anchoridR[i] >= 0)
		{
			if(MPGe[i/2] == MPGe[RPosi->anchoridR[i]/2])
				++TRT;
			else 
				++TRF;

			if(abs(StartPosition[i]-StartPosition[RPosi->anchoridR[i]])==RPosi->positionR[i])
				++RT;
			else
			{
				++RF;
				if(ccount2<10)
				{
					cout<<"StartPositionR:\t"<<StartPosition[i]<<"\t"<<StartPosition[RPosi->anchoridR[i]]<<"\t"<<RPosi->positionR[i]<<endl;
					++ccount2;
				}
			}
		}
	}
	cerr<<"LT:\t"<<LT<<endl;
	cerr<<"LF:\t"<<LF<<endl;
	cerr<<"RT:\t"<<RT<<endl;
	cerr<<"RF:\t"<<RF<<endl;

	cerr<<"TLT:\t"<<TLT<<endl;
	cerr<<"TLF:\t"<<TLF<<endl;
	cerr<<"TRT:\t"<<TRT<<endl;
	cerr<<"TRF:\t"<<TRF<<endl;
	vector<int>DisL(75,0);
	vector<int>DisR(75,0);
	for(int i=0;i<ReadNum;++i)
	{
		if(RPosi->anchoridL[i] >= 0)
			++DisL[RPosi->positionL[i]];
		if(RPosi->anchoridR[i] >= 0)
			++DisR[RPosi->positionR[i]];
	}
	for(int i=0;i<75;++i)
		cerr << i <<"\t" << DisL[i] << "\t" << DisR[i] << endl;
	*/

	cerr<<"INode:\t"<<INodePool.getNodeNum()<<endl;
////////////////////////////////////////////////////////
////mate-pair
	Type->ReInitial();
	for(int i=0;i<ReadNum;i+=2)
	{
		Type->Union(i+1,i);
	}
//////////////////////////////////////////////////////////////////////////////////
	if(isTest2){
		cerr <<"For long StrLen:" << endl;printtime();
	}
	USMerge(ITR,Type,LARGESIZE,ReadLen,Reads,RevReads,ReadLen+1,StrLen,IsOrphan);
	if(isTest2){
//		cerr<<"start to rmSameTypeNodes:"<<endl;printtime();
		testType();
	}
	//clearSameTypeNodes(ITR, Type);
//////////////////////////////////////////////////////////////////////////////////
	if(isTest2){
		cerr <<"For short StrLen:" << endl;	printtime();
	}
//	USMerge(ITR,Type,LARGESIZE,ReadLen,Reads,RevReads,StrLen,StrLenLowCover,IsOrphan);
	if(isTest2)
	{
		cerr<<"start to rmSameTypeNodes:"<<endl;printtime();
	}
	rmSameTypeNodes(Type);
	cerr<<"INode:\t"<<INodePool.getNodeNum()<<endl;

//	testType();
	cerr << "after merge:\ttestType(false,1000):\t" << endl;
	testType(false,1000);
	///////////////////////////////////
	//reduce space.
	vector<pairlong>().swap(ITR);
//	delete[]KmerMap;
//	KmerMap = NULL;
//////////////////////////////////////////////////////////////////////////////////
	if(isTest)
	{
		cerr<<"printsize here:"<<endl;
		printtime();
		printsize(false);
		cerr<<"Start to get neighbors. time is: ";
		printtime();
		system("ps ux ");
	}
	//exit(-1);
/////////////////////////////////////////////////////////////////////////////////
	KmerDistri = new int*[ReadNum/2];
	for(int i=0;i<ReadNum/2;++i)KmerDistri[i]=NULL;
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
	SparseMatrix SPMTX;
	int SPMTXSIZE = SPMTX.Size;
	omp_lock_t* hash_lock = new omp_lock_t[SPMTXSIZE];
	for(int i=0;i<SPMTXSIZE;++i)
		omp_init_lock(&hash_lock[i]);
	if(isTest2)
	{
		cerr<<"after ini locks:"<<endl;
		printtime();
	}
	const unsigned NodeNum = INodePool.getNodeNum();
#pragma omp parallel for schedule(dynamic)
	for(unsigned i1 = 0;i1< NodeNum;++i1)
	{
			IntNode* curr = INodePool.getRef(i1);
			int sub_size = curr->VSize;
			if(sub_size<2 || sub_size>100000)//because rmSameTypeNodes()
				continue;
	
			int* indexes=new int[sub_size];
			int* positions=new int[sub_size];int temp=0;
			int* isRev=new int[sub_size];
			for(NodeIDPosi* map_it2 = curr->myvector;map_it2 != (curr->myvector)+curr->VSize; ++map_it2)
			{
				if(IsOrphan[(*map_it2).id])continue;
				indexes[temp]=((*map_it2).id);
				isRev[temp]=((*map_it2).posi & 1U);//last bit is a flag
				positions[temp++]=((*map_it2).posi)>>1;//last bit is a flag
			}
			sub_size = temp;
	
			ULL4 read1,read2;
			for(int i=0;i<sub_size;++i)
			{
				int indexes1 = indexes[i];
	
				if(isRev[i])	read1 = RevReads[indexes1];
				else	read1 = Reads[indexes1];
	
				for(int j=i+1;j<sub_size;++j)
				{
					int indexes2 = indexes[j];
					if(Type->find(indexes1)==Type->find(indexes2))
						continue;
				/*	if(positions[i]-positions[j]>ReadLen-StrLen || positions[j]-positions[i]>ReadLen-StrLen)
						continue;
						*/
					if(positions[j]-positions[i]>ReadLen-StrLen)
						break;
					if(isRev[j])	read2 = RevReads[indexes2];
					else read2 = Reads[indexes2];
	
					int match,mismatch;
	
					compa_read(ReadLen,positions[i],positions[j],match,mismatch,read1,read2);
					//////////////////////////////get Neighbors
					if((match-StrLen>=0) &&(match-StrLen >= confidence[match+mismatch-StrLen]))
					{
						unsigned x = Type->find(indexes1);
						unsigned y = Type->find(indexes2);
						unsigned id = (x+y)%1048573;
						omp_set_lock(&hash_lock[id]);
						SPMTX.insert(x,y);
						SPMTX.insert(y,x);
						omp_unset_lock(&hash_lock[id]);
					}
				}
			}
			delete[]indexes;delete[]positions;delete[]isRev;
	}
	if(isTest2)
	{
		cerr<<"after paralization.:"<<endl;
		printtime();
	}
	/*
	for(int i=0;i<SPMTXSIZE;++i)
		omp_destroy_lock(&hash_lock[i]);
	delete[] hash_lock;
	*/
	SPMTX.toNeighbor(Neighbor);
	if(isTest2)
	{
		cerr<<" start to get 16mer count."<<endl;
		printtime();
	}
	//////////////////////////////////////////////////////////////
	////get kmer
#pragma omp parallel for schedule(dynamic)
	for(unsigned i1 = 0;i1< NodeNum;++i1)
	{
		IntNode* curr = INodePool.getRef(i1);
		int sub_size = curr->VSize;
		if(sub_size<2)//because rmSameTypeNodes()
			continue;

		map<unsigned,unsigned> candidate;
		for(NodeIDPosi* map_it2 = curr->myvector;map_it2 != (curr->myvector)+curr->VSize; ++map_it2)
			++candidate[Type->find((*map_it2).id)];
		for(map<unsigned,unsigned>::const_iterator itr2 = candidate.begin();itr2!=candidate.end();++itr2)
		{
			int clutype = (itr2->first)/2;
#pragma omp atomic
			Total16mer[clutype] += itr2->second;
#pragma omp atomic
			++Occur16mer[clutype];
		}
	}
	//////////////////////////////////////////////////////////////
	if(isTest2)
	{
		cerr<<" start to get 16mer count from SNode."<<SNodePool.getNodeNum()<<endl;
		printtime();
	}
	////////////////////////////////////////
	//removed same type:
	const unsigned SNodeNum = SNodePool.getNodeNum();
	const int SRowSizeBit = SNodePool.RowSizeBit;
	const unsigned SMASK = SNodePool.MASK;
//#pragma omp parallel for schedule(dynamic)
	if(isTest2)
		cerr<<"SNodeNum:\t"<<SNodeNum<<endl;
	//////////////////////////k
#pragma omp parallel for
	for(unsigned i = 0;i< SNodeNum;++i)
	{
		unsigned count,type;
		KmerType kmer;
		SNodePool.NodeArray[i>>SRowSizeBit][i&SMASK].getData(kmer,count,type);
	//	SNodePool.getData(i,kmer,count,type);
		type = (Type->find(type))/2;
#pragma omp atomic
		Total16mer[type] += count;
#pragma omp atomic
		++Occur16mer[type];
	}
	////////////////////////////////////////
	if(isTest2)
	{
		system("ps ux ");
		cerr << "Start to get k-mers . time is: ";
		printtime();
	}
	/////////////////////////////////////////////////////////////////
	//////////////////////get Reads back
	////switch back the reads
	/*
	for(unsigned i=0;i<ReadNum;i+=2)
	{
		unsigned long long low,mid_H,mid_L,high;
		low = Reads[i].low;mid_H=Reads[i].mid_H;mid_L=Reads[i].mid_L;high=Reads[i].high;
		Reads[i].low=RevReads[i].low;Reads[i].mid_H=RevReads[i].mid_H;Reads[i].mid_L=RevReads[i].mid_L;Reads[i].high=RevReads[i].high;
		RevReads[i].low=low;RevReads[i].mid_H=mid_H;RevReads[i].mid_L=mid_L;RevReads[i].high=high;
	}*/
	///////////////////////////////////////////////release extra space
	delete[] Reads;
	////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
////get friends
	omp_lock_t type_lock;
	omp_init_lock(&type_lock);
#pragma omp parallel for schedule(dynamic)
	for(unsigned i1 = 0;i1< NodeNum;++i1)
	{
			IntNode* curr = INodePool.getRef(i1);
			int sub_size = curr->VSize;
			if(sub_size<2)//because rmSameTypeNodes()
				continue;
	
			int* indexes=new int[sub_size];
			int* positions=new int[sub_size];int temp=0;
			int* isRev=new int[sub_size];
			for(NodeIDPosi* map_it2 = curr->myvector;map_it2 != (curr->myvector)+curr->VSize; ++map_it2)
			{
				indexes[temp]=((*map_it2).id);
				isRev[temp]=((*map_it2).posi & 1U);//last bit is a flag
				positions[temp++]=((*map_it2).posi)>>1;//last bit is a flag
			}
//////////////////////////////////////////////////////////////
			map<unsigned,unsigned> candidate;
			for(int i=0;i<sub_size;++i)
			{
				++candidate[Type->find(indexes[i])];
			}
			KmerType KmerTran = curr->kmer;
			for(map<unsigned,unsigned>::const_iterator itr2 = candidate.begin();itr2!=candidate.end();++itr2)
			{
				if(IsOrphan[itr2->first])continue;
				int clutype = (itr2->first)/2;
				int ThreshNStep2 = MinF[Total16mer[clutype]/Occur16mer[clutype]];
				if(ThreshNStep2 < 2)ThreshNStep2=2;

				if(itr2->second < ThreshNStep2)continue;
				omp_set_lock(&hash_lock[clutype%1048573]);
				if(KmerDistri[clutype]==NULL)
				{
					KmerDistri[clutype]=new int[NoReverSize];
					for(int i=0;i<NoReverSize;++i)
					{
						KmerDistri[clutype][i] = 0;
					}
				}
				for(int i=0;i<TRANLEN+1-MetaKmerLen;++i)
				{
					unsigned kmer4 = (KmerTran>>(2*i));
					if(MetaKmerLen == 4)
						++KmerDistri[clutype][kmer4 & 0xff];
					else
						++KmerDistri[clutype][kmer4 & 0x3ff];
				}
				Size16mer[clutype]++;
				omp_unset_lock(&hash_lock[clutype%1048573]);
			}
			delete[]indexes;delete[]positions;delete[]isRev;
			omp_set_lock(&type_lock);
			curr->clear();
			omp_unset_lock(&type_lock);
	}
	cout<<"before INodePool clear:\t"<<endl;system("ps ux");
	INodePool.clear();
	cout<<"after INodePool clear:\t"<<endl;system("ps ux");
	////////////////////////////////////////
	////////////////////////////////////////
	if(isTest2)
	{
		cerr << "Start to get from same-type. time is: ";
		printtime();
	}
#pragma omp parallel for schedule(dynamic)
	for(unsigned i1 = 0;i1< SNodeNum;++i1)
	{
		unsigned count,clutype;
		KmerType kmer;
		SNodePool.getData(i1,kmer,count,clutype);
		clutype = (Type->find(clutype))/2;
		int ThreshNStep2 = MinF[Total16mer[clutype]/Occur16mer[clutype]];
		if(ThreshNStep2 < 2)ThreshNStep2=2;

		if(count < ThreshNStep2)continue;
		omp_set_lock(&hash_lock[clutype%1048573]);
		if(KmerDistri[clutype]==NULL)
		{
			KmerDistri[clutype]=new int[NoReverSize];
			for(int i=0;i<NoReverSize;++i)
			{
				KmerDistri[clutype][i] = 0;
			}
		}
		for(int i=0;i<TRANLEN+1-MetaKmerLen;++i)
		{
			unsigned kmer4 = (kmer>>(2*i));
			if(MetaKmerLen == 4)
				++KmerDistri[clutype][kmer4 & 0xff];
			else
				++KmerDistri[clutype][kmer4 & 0x3ff];
		}
		Size16mer[clutype]++;
		omp_unset_lock(&hash_lock[clutype%1048573]);
	}
	SNodePool.clear();
	////////////////////////////////////////
	////////////////////////////////////////
	////////////////////////////////////////
	if(isTest2)
	{
		cerr << "Size of neighbors: " << Neighbor.size() << endl;
		cerr << "Start to bin neighbors. time is: ";
		printtime();
	}

	NSize = new int[ReadNum/2];
	for(int i=0;i<ReadNum/2;++i)NSize[i]=0;
	for(map<int,map<int,int> >::const_iterator itr = Neighbor.begin();itr != Neighbor.end();++itr)
	{
		NSize[itr->first/2]=itr->second.size();
	}
	if(isTest)
	{
		int mapsize = 0;
		int mapcount = 0;
		for(map<int,map<int,int> >::const_iterator itr = Neighbor.begin();itr != Neighbor.end();++itr)
		{
			mapcount += itr->second.size();
			mapsize += sizeof(itr->second);
		}
		cerr << "Neighbor Size:\t" << sizeof(Neighbor) << endl;
		cerr << "mapcount:\t" << mapcount << endl;
		cerr << "mapsize:\t" << mapsize << endl;
	}
/////////////////////////////////////////////////////////////////
	bool hasChange = true;
	int itercount = 0;
	while(hasChange)
	{
		if(isTest2)
			cerr<<"itercount :\t"<<itercount++<<endl;
		hasChange = false;
		for(map<int,map<int,int> >::const_iterator itr = Neighbor.begin();itr != Neighbor.end();++itr)
		{
			int type1 = Type->find(itr->first);
			if(type1==itr->first && NSize[type1/2] <3)
			{
				for(map<int,int>::const_iterator itr2 = itr->second.begin();itr2!=itr->second.end();++itr2)
				{
					int type2 = Type->find(itr2->first);
					if(type2==itr2->first && NSize[type2/2] <3 && type1 != type2)
					{
						furtherunion(type1,type2);
						hasChange = true;
					}
				}
			}
		}
	}
	for(unsigned i=0;i<ReadNum;i+=2)
	{
		if(Type->getsize(i)<1000 || Size16mer[(Type->find(i))/2]<1000)
			IsOrphan[i] =IsOrphan[i+1] = true;
	}
	cerr << "testType(true,1000):\t" << endl;
	testType(false,1000);
	cerr << "testType(false,1000):\t" << endl;
	testType(true,1000);
//////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
	if(isTest)
	{
		printsize(false);
		cerr<<"get long Contig:"<<endl;
	}
/////////////////////////////////////////////////////////////////
	if(useContig)
	{
		for(map<int,map<int,int> >::const_iterator itr = Neighbor.begin();itr != Neighbor.end();++itr)
		{
			int type1 = Type->find(itr->first);
			if(type1!=itr->first)continue;
		//	while( Type->getsize(type1)<SmallContig)
			while( Size16mer[(Type->find(type1))/2]<SmallContig)//Type->getsize(type1)<SmallContig)
			{
				double maxScore = 0;int maxType = -1;
				for(map<int,int>::const_iterator itr2 = itr->second.begin();itr2!=itr->second.end();++itr2)
				{
					int type2 = Type->find(itr2->first);
					if(type2==itr2->first && Type->find(type1) != type2)
					{
						double score = itr2->second/(double)Type->getsize(type2);
						if(score > maxScore)
						{
							maxScore = score;
							maxType  = type2;
						}
					}
				}
				if(maxType == -1)break;
				furtherunion(type1,maxType);
			}
		}
	}
	else
	{
		for(map<int,map<int,int> >::const_iterator itr = Neighbor.begin();itr != Neighbor.end();++itr)
		{
			int type1 = Type->find(itr->first);
			if(type1!=itr->first)continue;
			while( Type->getsize(type1)<SmallTSize)
			{
				double maxScore = 0;int maxType = -1;
				for(map<int,int>::const_iterator itr2 = itr->second.begin();itr2!=itr->second.end();++itr2)
				{
					int type2 = Type->find(itr2->first);
					if(type2==itr2->first && Type->find(type1) != type2)
					{
						double score = itr2->second/(double)Type->getsize(type2);
						if(score > maxScore)
						{
							maxScore = score;
							maxType  = type2;
						}
					}
				}
				if(maxType == -1)break;
				furtherunion(type1,maxType);
			}
		}
	}
	if(isTest)
		printsize(false);

	for(int i=0;i<ReadNum;++i)
	{
		if(Size16mer[(Type->find(i))/2]<Orphan16merThresh)
			IsOrphan[i] = true;
	}
	cerr << "testType(false,1000):\t" << endl;
	testType(false,1000);
	cerr << "testType(true,1000):\t" << endl;
	testType(true,1000);
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
	if(isTest2)
	{
		cerr << "Start to Switch Types. time is: ";
		printtime();
	}
	const int DisSize = 10000;
	int SmerDistri[DisSize];
	for(int i=0;i<DisSize;++i)SmerDistri[i]=0;
/////////////////////////////////////////////////////////////////
////get parameters for MetaCluster3 

	//////////////////////////////////////////////////////////
	//first, change orginanl Type id to consecutive small numbers
	map<int,int>ToNewType;
	map<int,int>ToOldType;
	int ordercounter = 0;
	for(int i=0;i<ReadNum;++i)
	{
		if(Type->find(i)==i && Type->getsize(i)>200)
		{
			if(KmerDistri[i/2]==NULL || IsOrphan[i])
			{
				continue;
			}
			ToOldType[ordercounter]=i;
			ToNewType[i]=ordercounter++;
		}
	}
	if(ordercounter <= 2)
	{
		cerr<<"Coverage too low!!Too few cluters after phase2!!"<<endl;
		exit(-1);
	}

	ofstream ofstnt((midfile+".tnt").c_str());
	for(int i=0;i<ReadNum;i+=2)
	{
		int typet = Type->find(i);
		if(ToNewType.count(typet)==0)
			ofstnt << i << "\t"<<typet << "\t" << -1 << endl;
		else 
			ofstnt << i << "\t"<<typet << "\t" << ToNewType[typet] << endl;
	}
	ofstnt.close();
	//////////////////////////////////////////////////////////
	//setcond, get contigsize, 16mer size and the component arrays
	int* ContigSize = new int[ordercounter];
	int* SixTMerSize = new int[ordercounter];
	int** Component = new int*[ordercounter];
	for(int i=0;i<ordercounter;++i)
	{
		ContigSize[i] = Type->getsize(ToOldType[i]);
		Component[i]=new int[GenoNum];
		for(int j=0;j<GenoNum;++j)
			Component[i][j] = 0;

		int oldtype = ToOldType[i];

		if(IsOrphan[oldtype])continue;
		SixTMerSize[i]=Size16mer[oldtype/2];
		++SmerDistri[Size16mer[oldtype/2]/500];
	}
	/*
	for(int i=0;i<ReadNum;i+=2)
	{
		int type = Type->find(i);

		if(ToNewType.count(type) != 0)
			Component[ToNewType[type]][MPGe[i/2]]+=2;
	}
	*/
	//////////////////////////////////////////////////////////
	//third, get 4-mer distribution and spearman arrays
	int** SpearDistri = new int*[ordercounter];
	int** Kmer4Distri = new int*[ordercounter];
	for(int i=0;i<ordercounter;++i)
	{
		SpearDistri[i] = toSpear(tomNormalize_rever(KmerDistri[ToOldType[i]/2],ReverPosition,MetaKmerLen,false),ReverSize);
		Kmer4Distri[i] = new int[NoReverSize];
		for(int j=0;j<NoReverSize;++j)
			Kmer4Distri[i][j] = KmerDistri[ToOldType[i]/2][j];
		for(int j=0;j<NoReverSize;++j)
		{
			int rever = tomReverComple(j,MetaKmerLen);
			if(j<=rever)
			{
				Kmer4Distri[i][j] += Kmer4Distri[i][rever];
				Kmer4Distri[i][rever] = Kmer4Distri[i][j];
			}
		}
	}
	/////////////////////////////////////////////////////////
	//for test: 16-mer size distribution
	if(isTest2)
	{
		int largeindex=DisSize-1;
		while(SmerDistri[largeindex]==0)largeindex--;
		cout<<"#. 16-mer size:"<<endl;
		for(int i=0;i<=largeindex;++i)
			if(SmerDistri[i]>0)
				cout << i*500 <<','<<SmerDistri[i]<<endl;
	}
////end of getting parameters for MetaCluster3 
/////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////
////output mid-file
	if(isTest2)
	{
		cerr << "Output mid-file. time is: ";
		printtime();
	}
	ofstream ofsfr(midfile.c_str());
	for(int i=0;i<ordercounter;++i)
	{
		ofsfr<<SixTMerSize[i]<<"\t";
		for(int j=0;j<NoReverSize;++j)
			ofsfr<<Kmer4Distri[i][j]<<"\t";
		for(int j=0;j<GenoNum;++j)
			ofsfr<<Component[i][j]<<"\t";
		ofsfr<<endl;
	}
	ofsfr.close();
////end of outputting mid-file
/////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////
////start MetaCluster 3.0
	if(isTest2)
	{
		cerr << "Start K-means. time is: ";
		printtime();
	}
	MetaCluster meta(MetaKmerLen,ordercounter,SpearDistri,Kmer4Distri,SixTMerSize,GenoNum,Component,0,MaxSpecies,MinSpecies);
	if(ClusterSize)
		meta.muiltkmeans(10,ClusterSize);
	else 
		meta.iterMeta(10,MC3_Thresh);

/////////////////////////////////////////////////////////////////
////output reads
	/////////////////////////////////////////////////////////////////
	////get the final type
	int* finaltype = new int[ReadNum];
	for(int i=0;i<ReadNum;++i)
	{
		if(!IsOrphan[i])
			finaltype[i] = meta.best[ToNewType[Type->find(i)]];
		else finaltype[i] = -1;
	}
	//Cal precision and sensitivity
	int ClustNum = 0;
	for(int i=0;i<ReadNum;++i)
	{
		if(finaltype[i] > ClustNum)
			ClustNum = finaltype[i];
	}++ClustNum;

	if(isTest)
	{
		printAcc(finaltype,ClustNum);
	}
	/////////////////////////////////////////////////////////////////
	////output the reads
	ofstream ofstrl(outputStr.c_str());
	bool has = true;
	for(int i=0;i<ClustNum;++i)
	{
		if(has)
		ofstrl << "Clusters : "<<i <<endl;
		has = false;
		for(int j=0;j<ReadNum;j+=2)
		{
			if(finaltype[j] == i && !IsOrphan[j])
			{
				ofstrl<<strings[j]<<endl;
	//			string read1 = getreadstr(RevReads[j]);
	//			ofstrl<<read1<<endl;
				ofstrl<<strings[j+1]<<endl;
	//			string read2 = getreadstr(RevReads[j+1]);
	//			ofstrl<<read2<<endl;
				has = true;
			}
		}
	}
	ofstrl.close();

	ofstrl.open((file+".2").c_str());
	for(int j=0;j<ReadNum;j+=2)
	{
		if(IsOrphan[j])
		{
			ofstrl<<strings[j]<<endl;
//			ofstrl<<"Read_"<<j<<endl;//<<"\t"<<StartPosition[j]<<endl;
//			ofstrl<<"Read_"<<MPGe[j/2]<<'/'<<j<<"\t"<<StartPosition[j]<<endl;
			string read1 = getreadstr(RevReads[j]);
			ofstrl<<read1<<endl;
			ofstrl<<strings[j+1]<<endl;
//			ofstrl<<"Read_"<<j+1<<endl;//<<"\t"<<StartPosition[j]<<endl;
//			ofstrl<<"Read_"<<MPGe[j/2]<<'/'<<j<<"\t"<<StartPosition[j+1]<<endl;
			string read2 = getreadstr(RevReads[j+1]);
			ofstrl<<read2<<endl;
		}
	}
	ofstrl.close();
////end of outputting reads
/////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////
////get time
	if(isTest2)
	{
		cerr<<"binning ending time is:";
		printtime();
	}
/////////////////////////////////////////////////////
	if(isTest)
	{
		//printlinks();
		printCover();
		//printsize(false);
		cerr<<"ending time is: ";
		printtime();
		system("ps ux ");
	}
	//cerr<<"revs :\t"<<revs[0]<<"\t"<<revs[1] << "\t" << revs[2]<<endl;
/////////////////////////////////////////////////////
}
